﻿テキストの挟み込み機能設定:
	Gui,3: New
	;=========================================== 機能設定画面を操作不可にする
	Gui,1:Hide
	;-------------------------------------- 既に設定画面を開いているときは何もしない
	IfWinExist テキストの挟み込み機能設定
	{
		Return
	}
	;=========================================== フォントの設定
	Gui,3: Font, s11, 
	;=========================================== テキストの挟み込みリストビュー
	Gui,3: Add, GroupBox, x22 y9 w860 h360 , 登録内容
	Gui,3: Add, ListView, x42 y39 w820 h230 NoSortHdr Grid -Multi AltSubmit vEncloseLV gOnActionEncloseLV, メニュー表示|挟み込みテキスト（先頭）|挟み込みテキスト（末尾）
	Gui,3: Add, Button, x492 y279 w40 h30 disabled1 vEncloseUpBtn gEncloseUp, ↑
	Gui,3: Add, Button, x542 y279 w40 h30 disabled1 vEncloseDownBtn gEncloseDown, ↓
	Gui,3: Add, Button, x782 y279 w70 h30 disabled1 vEncloseDeleteBtn gEncloseDelete, 削除
	Gui,3: Add, Button, x622 y319 w230 h30 disabled1 vEncloseSaveBtn gEncloseSave, 保存
	;--------------- 定型文のコンテンツとメニューを読み込んで定型文リストビューに追加する
	loop {
		Section = ENCLOSE_TEXT%A_Index%
		IniRead, ET_EncloseMenuText, %IniFileName%, %Section%, MenuText, -1
		If (ET_EncloseMenuText == -1) {
			Break
		}
		IniRead, ET_EncloseLeftText, %IniFileName%, %Section%, LeftText, -1
		IniRead, ET_EncloseRightText, %IniFileName%, %Section%, RightText, -1
		LV_Add("", ET_EncloseMenuText, ET_EncloseLeftText, ET_EncloseRightText)
	}
	;--------------- リストビューの列幅を調整する
	LV_ModifyCol(1,"AutoHdr")
	LV_ModifyCol(2,"AutoHdr")
	LV_ModifyCol(3,"AutoHdr")
	;=========================================== テキストの挟み込みの内容
	Gui,3: Add, GroupBox, x22 y379 w860 h310 , 挟み込みテキスト
	Gui,3: Add, Text, x42 y409 w170 h20 , 挟み込みテキスト（先頭）
	Gui,3: Add, Edit, x42 y429 w380 h160 vEncloseLeftText gOnChangeEncloseLeftText, 
	Gui,3: Add, Text, x482 y409 w170 h20 , 挟み込みテキスト（末尾）
	Gui,3: Add, Edit, x482 y429 w380 h160 vEncloseRightText gOnChangeEncloseRightText, 
	Gui,3: Add, Button, x182 y599 w230 h30 disabled1 vCopyEncloseLeftTextToMenuBtn gCopyEncloseLeftTextToMenu, メニュー表示にコピー
	Gui,3: Add, Text, x42 y629 w90 h20 , メニュー表示
	Gui,3: Add, Edit, x42 y649 w380 h20 vEncloseMenuText gOnChangeEncloseMenuText, 
	Gui,3: Add, Button, x502 y639 w90 h30 disabled1 vEncloseTextClearBtn gEncloseTextClear, クリア
	Gui,3: Add, Button, x622 y599 w230 h30 disabled1 vEncloseTextAddBtn gEncloseTextAdd, 追加
	Gui,3: Add, Button, x622 y639 w230 h30 Disabled1 vEncloseTextModifyBtn gEncloseTextModify, 変更
	;=========================================== 前回終了時に設定画面が表示されていた場合はリストビューの選択状態を復元する
	IniRead,strWrk,%IniFileName%,AUTOEXEC,StartUp,0
	If (strWrk == 1) {
		;--------------- 再表示指定をクリアする
		IniWrite,0,%IniFileName%,AUTOEXEC,StartUp
		;--------------- 定型文グループリストビューの選択状態を復元する
		IniRead,strWrk,%IniFileName%,AUTOEXEC,ET_SelectedRow
		If (strWrk > 0) {
			Gui,3:ListView,EncloseLV
			LV_Modify(strWrk, "Select")
			SelectedRow := strWrk
			Gosub ExpandEncloseText
		}
	}
	Gui,3: Add, Button, x782 y698 w100 h30 g3ConfigClose, 閉じる
	;=========================================== 画面表示
	Gui,3: Show, h741 w907, テキストの挟み込み機能設定
Return
;=========================================== リストビューの項目が選択されたときの処理
OnActionEncloseLV:
	;-------------------------------------- リストビューがフォーカスを受け取ったときは、処理対象のリストビューを変更する
	If (A_GuiEvent == "F" || A_GuiEvent == "Normal") {
		Gui, 3: ListView, EncloseLV
	}
	;-------------------------------------- リストビューの選択状態が変化したときは、リストビューにフォーカスをあわせる（ここでフォーカスをあててないと次にリストビューの項目をクリックしたときに正しくイベントが受け取れないため）
	If (A_GuiEvent == "I") {		
		GuiControl, Focus, EncloseLV
		Return
	}
	;------------------------------ 選択されている行の行番号を取得する
	SelectedRow := LV_GetNext(0)
	;------------------------------ 項目が埋まっている行がクリックされたときだけ処理する
	If (A_GuiEvent == "Normal" || (A_GuiEvent == "K" && (A_EventInfo == "38" || A_EventInfo == "40"))) {
		If (SelectedRow > 0) {
			;-------------------------------------- 挟み込みテキストの登録内容を展開する
			Gosub ExpandEncloseText
		}Else{
			;-------------------------------------- ボタンを押せないようにする
			GuiControl, Enable0, EncloseUpBtn
			GuiControl, Enable0, EncloseDownBtn
			GuiControl, Enable0, EncloseDeleteBtn
			GuiControl, Enable0, CopyEncloseLeftTextToMenuBtn
			GuiControl, Enable0, EncloseTextClearBtn
		}
	}
Return
;=========================================== 挟み込みテキストの登録内容を展開する
ExpandEncloseText:
	IF (SelectedRow > 0) {
		;-------------------------------------- 選択された行の設定をエディットボックスに追加する
		;-------------------------------------- メニュー表示をリストビューから取得しエディットボックスに表示する
		LV_GetText(strWrk, SelectedRow, 1)
		GuiControl, Text, EncloseMenuText, %strWrk%
		SelectedEncloseMenuText := strWrk
		;-------------------------------------- テキストの挟み込み（先頭）を取得しリストビューからエディットボックスに表示する
		LV_GetText(strWrk, SelectedRow, 2)
		;-------------------------------------- 改行を復元
		Gosub DecodeLFCR_TAB
		GuiControl, Text, EncloseLeftText, %strWrk%
		;-------------------------------------- テキストの挟み込み（末尾）を取得しリストビューからエディットボックスに表示する
		LV_GetText(strWrk, SelectedRow, 3)
		;-------------------------------------- 改行を復元
		Gosub DecodeLFCR_TAB
		GuiControl, Text, EncloseRightText, %strWrk%
		;-------------------------------------- ボタンを制御する
		GuiControl, Enable1, EncloseUpBtn
		GuiControl, Enable1, EncloseDownBtn
		GuiControl, Enable1, EncloseDeleteBtn
		GuiControl, Enable1, CopyEncloseLeftTextToMenuBtn
	}
Return
;=========================================== ↑ボタンを押したときの処理
EncloseUp:
	;-------------------------------------- 選択されている行を上げる
	EncloseUpDown("Up")
Return
;=========================================== ↓ボタンを押したときの処理
EncloseDown:
	;-------------------------------------- 選択されている行を下げる
	EncloseUpDown("Down")
Return
;=========================================== リストビューを上下する
EncloseUpDown(UpDown) {
	;-------------------------------------- 選択されている行の番号を取得する
	SelectedRow := LV_GetNext(0)
	If (UpDown == "Up") {
		If (SelectedRow > 1) {
			AltRow := SelectedRow - 1
		}Else{
			AltRow := 0
		}
	}Else{
		If (SelectedRow < LV_GetCount()) {
			AltRow := SelectedRow + 1
		}Else{
			AltRow := 0
		}
	}
	If (AltRow > 0) {
		;-------------------------------------- メニュー表示をリストビューから取得し配列に保存する
		EncloseMenuTextMem := Object()
		EncloseLeftTextMem := Object()
		EncloseRightTextMem := Object()
		LV_Count := LV_GetCount()
		Loop %LV_Count% {
			LV_GetText(strWrk, A_Index, 1)
			EncloseMenuTextMem[A_Index] := strWrk
			LV_GetText(strWrk, A_Index, 2)
			EncloseLeftTextMem[A_Index] := strWrk
			LV_GetText(strWrk, A_Index, 3)
			EncloseRightTextMem[A_Index] := strWrk
		}
		;-------------------------------------- 順番を変更する
		Wrk := EncloseMenuTextMem[AltRow]
		EncloseMenuTextMem[AltRow] := EncloseMenuTextMem[SelectedRow]
		EncloseMenuTextMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := EncloseLeftTextMem[AltRow]
		EncloseLeftTextMem[AltRow] := EncloseLeftTextMem[SelectedRow]
		EncloseLeftTextMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := EncloseRightTextMem[AltRow]
		EncloseRightTextMem[AltRow] := EncloseRightTextMem[SelectedRow]
		EncloseRightTextMem[SelectedRow] := Wrk
		;-------------------------------------- リストビューをいったん削除する
		LV_Delete()
		;-------------------------------------- リストビューを再構築する
		loop %LV_Count% {
			LV_Add("", EncloseMenuTextMem[A_Index], EncloseLeftTextMem[A_Index], EncloseRightTextMem[A_Index])
		}
		;--------------- リストビューの列幅を調整する
		LV_ModifyCol(1,"AutoHdr")
		LV_ModifyCol(2,"AutoHdr")
		LV_ModifyCol(3,"AutoHdr")
		;-------------------------------------- 移動した行を選択する
		LV_Modify(AltRow,"Select Vis")
		;-------------------------------------- 保存ボタンを押せるようにする
		GuiControl, Enable1, EncloseSaveBtn
	}
}
;=========================================== 削除ボタンを押したときの処理
EncloseDelete:
	;-------------------------------------- 選択されている定型文を削除する（DeleteSelectedRow関数は定型文画面のスクリプトで定義）
	Rs := DeleteSelectedRow()
	If (Rs == 0) {
		;-------------------------------------- ボタンを制御する
		GuiControl, Enable1, EncloseSaveBtn
		GuiControl, Enable0, EncloseUpBtn
		GuiControl, Enable0, EncloseDownBtn
		GuiControl, Enable0, EncloseDeleteBtn
	}
Return
;=========================================== 保存ボタンを押したときの処理
EncloseSave:
	;SplashImage,,B1 FM12 CWFFFFA2,,テキストの挟み込み設定を保存しています
	;-------------------------------------- リストビューを処理対象に変更する
	Gui,3:ListView,EncloseLV
	;-------------------------------------- リストビューに表示されている定型文をiniファイルに保存する
	LV_Count := LV_GetCount()
	Loop %LV_Count% {
		Section = ENCLOSE_TEXT%A_Index%
		;-------------------------------------- メニューテキストをiniファイルに保存する
		LV_GetText(strWrk, A_Index, 1)
		IniWrite,%strWrk%,%IniFileName%,%Section%,MenuText
		;-------------------------------------- 挟み込みテキスト（先頭）をiniファイルに保存する
		LV_GetText(strWrk, A_Index, 2)
		IniWrite,%strWrk%,%IniFileName%,%Section%,LeftText
		;-------------------------------------- 挟み込みテキスト（末尾）をiniファイルに保存する
		LV_GetText(strWrk, A_Index, 3)
		IniWrite,%strWrk%,%IniFileName%,%Section%,RightText
	}
	;-------------------------------------- 不要なiniファイルの項目を削除する
	ix := LV_Count + 1
	Loop {
		Section = ENCLOSE_TEXT%ix%
		IniRead, strWrk, %IniFileName%, %Section%, MenuText, -1
		If (strWrk == -1) {
			Break
		}
		IniDelete,%IniFileName%,%Section%
		ix += 1
	}
	;-------------------------------------- スプラッシュ表示を消去する
	;SplashImage,off
	;MsgBox テキストの挟み込み設定を保存しました
	;-------------------------------------- 再表示時に復元できるようにリストビューの選択状態を保存してリロードする
	Gosub SaveLastSessionAndReloadET
Return
;=========================================== 挟み込みテキスト（先頭）を入力した時の処理
OnChangeEncloseLeftText:
	Gosub OnChangeEncloseText
Return
;=========================================== 挟み込みテキスト（末尾）を入力した時の処理
OnChangeEncloseRightText:
	Gosub OnChangeEncloseText
Return
;=========================================== メニューテキストを入力した時の処理
OnChangeEncloseMenuText:
	Gosub OnChangeEncloseText
Return
;=========================================== 挟み込みテキストを入力した時の処理
OnChangeEncloseText:
	Gui,3: Submit ,NoHide
	;-------------------------------------- テキストの挟み込みリストビューを処理対象に変更する
	Gui,3:ListView,EncloseLV
	SelectedRow := LV_GetNext(0)
	If (SelectedRow > 0) {
		GuiControlGet, strWrk , FocusV
		If (strWrk == "EncloseLV") {
			;--------------- リストビューがアクティブになっているときは定型文の変更ボタンを押せないようにする
			GuiControl, Enable0, EncloseTextModifyBtn
		}Else{
			If (StrLen(EncloseMenuText) > 0 && StrLen(EncloseLeftText) > 0 && StrLen(EncloseRightText) > 0) {
				;--------------- 変更ボタンを押せるようにする
				GuiControl, Enable1, EncloseTextModifyBtn
			}Else{
				;--------------- 変更ボタンを押せないようにする
				GuiControl, Enable0, EncloseTextModifyBtn
				;--------------- コピーボタンを制御する
				If (StrLen(EncloseLeftText) > 0) {
					GuiControl, Enable1, CopyEncloseLeftTextToMenuBtn
				}Else{
					GuiControl, Enable0, CopyEncloseLeftTextToMenuBtn
				}
			}
		}
	}Else{
		;--------------- 変更ボタンを押せないようにする
		GuiControl, Enable0, EncloseTextModifyBtn
		;--------------- コピーボタンを制御する
		If (StrLen(EncloseLeftText) > 0) {
			GuiControl, Enable1, CopyEncloseLeftTextToMenuBtn
		}Else{
			GuiControl, Enable0, CopyEncloseLeftTextToMenuBtn
		}
	}
	;--------------- 追加ボタンを制御する
	If (StrLen(EncloseLeftText) > 0 && StrLen(EncloseRightText) > 0 && StrLen(EncloseMenuText) > 0 && SelectedEncloseMenuText <> EncloseMenuText) {
		;---------------挟み込むテキスト定型文とメニュー表示が入力されていて、メニュー表示が定型文リストビューの選択されている内容と違う時だけ押せるようにする
		GuiControl, Enable1, EncloseTextAddBtn
	}Else{
		GuiControl, Enable0, EncloseTextAddBtn
	}
	;--------------- クリアボタンを制御する
	If (StrLen(EncloseMenuText) > 0 || StrLen(EncloseLeftText) > 0 || StrLen(EncloseRightText) > 0) {
		GuiControl, Enable1, EncloseTextClearBtn
	}Else{
		GuiControl, Enable0, EncloseTextClearBtn
	}
Return
;=========================================== コピーボタンを押したときの処理
CopyEncloseLeftTextToMenu:
	Gui,3: Submit ,NoHide
	GuiControl, Text, EncloseMenuText, %EncloseLeftText%%EncloseRightText%
Return
;=========================================== クリアボタンを押したときの処理
EncloseTextClear:
	GuiControl, Text, EncloseLeftText,
	GuiControl, Text, EncloseRightText,
	GuiControl, Text, EncloseMenuText,
	GuiControl, Enable0, CopyEncloseLeftTextToMenuBtn
	GuiControl, Enable0, EncloseTextAddBtn
	GuiControl, Enable0, EncloseTextModifyBtn
	;--------------- 挟み込みテキスト（先頭）にフォーカスを移してクリアボタンを押せなくする
	GuiControl, Focus , EncloseLeftText
Return
;=========================================== 追加ボタンを押したときの処理
EncloseTextAdd:
	;-------------------------------------- エディットボックスの内容を取得する
	Gui,3: Submit ,NoHide
	;-------------------------------------- 改行を置換
	strWrk := EncloseLeftText
	Gosub EncodeLFCR_TAB
	strWrk2 := strWrk
	;-------------------------------------- 改行を置換
	strWrk := EncloseRightText
	Gosub EncodeLFCR_TAB
	;--------------------------------------リストビューに追加する
	LV_Add("", EncloseMenuText, strWrk2 ,strWrk)
	;-------------------------------------- リストビューの列幅を調整する
	LV_ModifyCol(1,"AutoHdr")
	LV_ModifyCol(2,"AutoHdr")
	LV_ModifyCol(3,"AutoHdr")
	;-------------------------------------- 保存ボタンを押せるようにする
	GuiControl, Enable1, EncloseSaveBtn
Return
;=========================================== 変更ボタンを押したときの処理
EncloseTextModify:
	;-------------------------------------- エディットボックスの内容を取得する
	Gui,3: Submit ,NoHide
	;-------------------------------------- 改行を置換
	strWrk := EncloseLeftText
	Gosub EncodeLFCR_TAB
	strWrk2 := strWrk
	;-------------------------------------- 改行を置換
	strWrk := EncloseRightText
	Gosub EncodeLFCR_TAB
	;-------------------------------------- 選択されている行の番号を取得する
	SelectedRow := LV_GetNext(0)
	;--------------------------------------リストビューを変更する
	LV_Modify(SelectedRow, "Select", EncloseMenuText, strWrk2, strWrk)
	;--------------- リストビューの列幅を調整する
	LV_ModifyCol(1,"AutoHdr")
	LV_ModifyCol(2,"AutoHdr")
	LV_ModifyCol(3,"AutoHdr")
	;-------------------------------------- 保存ボタンを押せるようにする
	GuiControl, Enable1, EncloseSaveBtn
Return
;=========================================== GUI画面を閉じたときの処理
3ConfigClose:
3GuiClose:
	;-------------------------------------- リロード後、設定画面を再表示させるように設定する
	IniWrite,1,%IniFileName%,AUTOEXEC,StartUp
	IniWrite,機能設定,%IniFileName%,AUTOEXEC,ShowConfigPanel
	;-------------------------------------- リロード後の復元情報をクリアする
	IniWrite,0,%IniFileName%,AUTOEXEC,ET_SelectedRow
	;-------------------------------------- リロードして設定を反映させる
	Reload
Return
;=========================================== 再表示時に復元できるようにリストビューの選択状態を保存してリロードする
SaveLastSessionAndReloadET:
	;-------------------------------------- リストビューの選択されている行番号を取得して保存する
	Gui,3:ListView,EncloseLV
	SelectedRow := LV_GetNext(0)
	IniWrite,%SelectedRow%,%IniFileName%,AUTOEXEC,ET_SelectedRow
	;-------------------------------------- リロード後、設定画面を再表示させるように設定する
	IniWrite,1,%IniFileName%,AUTOEXEC,StartUp
	IniWrite,テキストの挟み込み機能設定,%IniFileName%,AUTOEXEC,ShowConfigPanel
	;-------------------------------------- リロードして設定を反映させる
	Reload
Return